﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace MatrixIO.IO.Bmff.Boxes
{
    /// <summary>
    /// JPEG2000 Header Box ("jp2h")
    /// </summary>
    [Box("jp2h", "JPEG2000 Header Box")]
    public class Jp2HeaderBox: Box, ISuperBox
    {
        public Jp2HeaderBox() : base() { }
        public Jp2HeaderBox(Stream stream) : base(stream) { }

        private IList<Box> _Children = Portability.CreateList<Box>();
        public IList<Box> Children
        {
            get { return _Children; }
        }

        public IEnumerator<Box> GetEnumerator()
        {
            return Children.GetEnumerator();
        }

        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return Children.GetEnumerator();
        }
    }
}
